//////////////////////////////////////////////////////////////
///////
///////      MP3_dq}XJbg_ver3.10
///////      by.yasuyuki ishizuka
///////      http://www.zea.jp/audio/
///////      2006.05.17
///////
///////      read_VFAT_info֐́u䂫̌v
///////      http://yuki-lab.jp/ ̋𓾂č쐬/Љ
///////
///////      CCS-C_PCHRpCgp
///////
//////////////////////////////////////////////////////////////

#include <18F252.h>
//#inciude <18F242.h>
#device ADC=10
#fuses H4, OSCSEN, NOWDT, PUT, CCP2B3, NOSTVREN, NOLVP, NOPROTECT,
#use delay(CLOCK=40000000)         //PLLmode


////////////////////////////////
//
// o͖
//
////////////////////////////////

#define      SW_POWER   PIN_A1      //POWER&POSE_SW_input
#define      SW_REW      PIN_A2      //REW_SW_input
#define      SW_FF      PIN_A3      //FF_SW_input
#define      SW_VOLDOWN   PIN_A4      //VOL_DOWN_SW_input
#define      SW_VOLUP   PIN_A5      //VOL_UP_SW_input

#define      MP3_SI      PIN_B1      //VS10xx_output
#define      MP3_SCLK   PIN_B2      //VS10xx_output
#define      MP3_CS      PIN_B3      //VS10xx_output
#define      MP3_BSYNC   PIN_B4      //VS10xx_output
#define      MP3_DCLK   PIN_B5      //VS10xx_output
#define      MP3_DREQ   PIN_B6      //VS10xx_input
#define      MP3_RS      PIN_B7      //VS10xx_output

#define      SPI_CS      PIN_C0      //SDCARD_CS_output_intH
#define      SPI_DI      PIN_C1      //SDCARD_Din_output_intH
#define      SPI_CK      PIN_C2      //SDCARD_SCK_output_intH
#define      SPI_DO      PIN_C3      //SDCARD_Dout_input
#define      POWER_LOCK   PIN_C4      //POWER_LOCK_line_output
#define      LED_OUT      PIN_C5      //LED_output


////////////////////////////////
//
// ̈
//
////////////////////////////////

//int   const BEEP_H[8] = {0x53,0xEF,0x6E,0x52,0,0,0,0};   //1500Hz TEST TONE(VS1001)
//int   const BEEP_L[8] = {0x53,0xEF,0x6E,0x40,0,0,0,0};   //750Hz TEST TONE(VS1001)
int   const BEEP_H[8] = {0x53,0xEF,0x6E,0xF0,0,0,0,0};   //1500Hz TEST TONE(VS1011)
int   const BEEP_L[8] = {0x53,0xEF,0x6E,0xE8,0,0,0,0};   //750Hz TEST TONE(VS1011)
int   const BEEP_S[8] = {0x45,0x78,0x69,0x74,0,0,0,0};   //STOP

char   VOLUME;
char   VOLDOWN_SCAN;   //Interruption scan of volumeDOWN switch
char   VOLUP_SCAN;   //Interruption scan of volumeUP switch
char   VOLCON_FLAG;   //The flag of carrying out volume-ADJ
char   POWEROFF_FLAG;   //The flag of carrying out POWEROFF
char   POWER_FLAG;   //The flag of carrying out POWER
char   POWER_SCAN;   //Interruption scan of POWER switch
char   FF_FLAG;   //The flag of carrying out FF
char   FF_SCAN;   //Interruption scan of FF switch
char   REW_FLAG;   //The flag of carrying out REW
char   REW_SCAN;   //Interruption scan of REW switch
char   LED_FLAG;
char   LED_SCAN;
char   POSE_FLAG;

char   NEXT_SDIR_FLAG;
char   BACK_SDIR_FLAG;


long   adv;         //ADϊp
char   musicreset;
char   RAM[128];
char   S_P_Cluster;
int32   RDE_Cnt;
int32   FAT_St;
int32   DIR_St;
int32   DATA_St;

int16   Cluster;      // ĐNX^
int16   NextCluster;      // NX^

int32   MP3_Size;      // Ȃ̃TCY
int32   RemainSec;      // Ȃ̎cZN^
int32   FAT_sec;
int   FAT_RAM[512];


char   SDIR_Cnt;      // TufBNg
int   file_Cnt[32];      // SDJ[hMP3t@C(ő32tH_܂)

char   playMP3_SDIR;      // IꂽTufBNg(0̓[g)***********1
char   playMP3_Num;      // ĐMP3t@C*****************************2



////////////////////////////////
//
// ֐Xg
//
////////////////////////////////

void   beep(char tone, char n);
void   VS10xxRESET(void);
void   VS10xxCOMM(char addr,int16 arg);
void   VS10xxWR(char data);
void   battchek(void);
void   POWEROFF(char c);
char   SDRESET(VOID);
char   SDRX(VOID);
void   SDTX(char c);
char   SDCMD(char cmd,int32 arg);
char   SPI_read_open(int32 adrs);
void   SPI_read_close(void);
void   read_32(int32 addr);
char   read_VFAT_info(void);
char   search_MP3(char num);         //[gMP3t@C
int16   read_word(int32 addr);
int16   next_cluster(int16 c);
char   play_music(int fn);


char   search_SDIR(char num);         //TufBNg
char   search_SDIR_MP3(char num);      //TufBNgMP3t@C
void   search_play_file(int num, int sdir);   //Đׂt@CĂяo
void   SD_mp3_check(void);         //SDzo
char   SD_Total_MP3(void);         //g[^MP3t@C
char   check_eeprom(void);         //W[̖mF
char   NEXT_search_SDIR(void);         //TufBNgMP3t@CLmF:i
char   BACK_search_SDIR(void);         //TufBNgMP3t@CLmF:߂



////////////////////////////////
//
// 荞
//
////////////////////////////////

#int_timer0

timer0_isr(){

   set_timer0(0xEC78);         //8msvZbg

   if(!(input(SW_POWER)))         //POWER&POSE_SWmF
   {
      if(++POWER_SCAN==0xFF)
         POWER_SCAN=0xFE;
      if(POWER_SCAN==0x7D)      //XLtO0x7Dœdoffm(|[Y@\Ȃ0x05)
      {
         beep(0,1);
         POWEROFF_FLAG=1;
      }
      if(POWER_SCAN > 6)      //XLtO6ȏŃXCb`L
         POWER_FLAG=1;      //ꎞ~/ĐĊJ
   }
   else
   {
      POWER_SCAN=0;         //XCb`ĂȂ΃tONA
   }


   if(!(input(SW_FF)))         //FF_SWmF
   {
      if(++FF_SCAN==0xFF)
         FF_SCAN=0xFE;
      if(FF_SCAN==0x7D)      //XLtO0x7DŎSDIRɈړ
      {
         NEXT_SDIR_FLAG=1;
      }
      if(FF_SCAN > 6)         //XLtO6ȏŃXCb`L
         FF_FLAG=1;
   }
   else
   {
      FF_SCAN=0;
      FF_FLAG=0;
      NEXT_SDIR_FLAG=0;
   }


   if(!(input(SW_REW)))
   {
      if(++REW_SCAN==0xFF)
         REW_SCAN=0xFE;
      if(REW_SCAN==0x7D)      //XLtO0x7DőOSDIRɈړ
      {
         BACK_SDIR_FLAG=1;
      }
      if(REW_SCAN > 6)      //XLtO6ȏŃXCb`L
         REW_FLAG=1;
   }
   else
   {
      REW_SCAN=0;
      REW_FLAG=0;
      BACK_SDIR_FLAG=0;
   }


   if(!(input(SW_VOLDOWN)))
   {
      if(++VOLDOWN_SCAN > 0x10)   //s[gTCN
         VOLDOWN_SCAN = 0;
      if(VOLDOWN_SCAN == 6)      //XLtO6ȏŃXCb`L
      {
         VOLUME+=4;      //{[ω
         if(VOLUME > 0xD0)   //Œl
            VOLUME=0xD0;
            VOLCON_FLAG=1;
      }
   }
   else
   {   
      VOLDOWN_SCAN=0;
   }


   if(!(input(SW_VOLUP)))
   {
      if(++VOLUP_SCAN > 0x10)      //s[gTCN
         VOLUP_SCAN = 0;
      if(VOLUP_SCAN == 6)      //XLtO6ȏŃXCb`L
      {
         VOLUME-=2;      //{[ω
         if(VOLUME < 0x02)   //ōl
            VOLUME=0x02;
            VOLCON_FLAG=1;
      }
   }
   else
   {   
      VOLUP_SCAN=0;
   }


   if(POSE_FLAG)
   {
      ++LED_SCAN;
      if(LED_SCAN >= 0x14)      //ꎞ~LED_ŃTCN
      {
         if(LED_FLAG)
         {
            LED_FLAG=0;
         }
         else
         {
            LED_FLAG=1;
         }
      LED_SCAN=0;
      }
   }

}




////////////////////////////////
//
// C
//
////////////////////////////////

void main()
{

   output_a(0);
   output_b(0);
   output_c(0x17);         //dIAcsAckAdi\ߗĂĂ

   setup_adc_ports(RA0_ANALOG);   //RA0̂݃AiO
   setup_adc(ADC_CLOCK_DIV_64);   //ōxADC
   set_tris_a(0x1F);
   set_tris_b(0x40);
   set_tris_c(0x08);

   output_low(MP3_RS);      //VS10xxn[hZbg

   musicreset=0;

   output_high(POWER_LOCK);   //dbN
   output_high(LED_OUT);
   output_high(MP3_RS);
   while(!(input(SW_POWER)));   //power{^𗣂܂ő҂

   if(!(input(SW_FF)))      //ff{^Ă΋ȔԃNA
      musicreset=1;
   while(!(input(SW_FF)));      //ff{^𗣂܂ő҂


   VOLDOWN_SCAN=0;         //Ô߃NA
   VOLUP_SCAN=0;
   VOLCON_FLAG=0;
   POWEROFF_FLAG=0;
   POWER_FLAG=0;
   POWER_SCAN=0;
   FF_FLAG=0;
   FF_SCAN=0;
   REW_FLAG=0;
   REW_SCAN=0;
   LED_FLAG=0;
   LED_SCAN=0;
   POSE_FLAG=0;
   NEXT_SDIR_FLAG=0;
   BACK_SDIR_FLAG=0;


   //output_high(SPI_CS);///////////////////
   //output_high(SPI_CK);///////////////////
   //output_high(SPI_DI);///////////////////

   setup_timer_0(RTCC_INTERNAL | RTCC_DIV_16);   //^C}[016rbg[h
   set_timer0(0xEC78);            //8msvZbg
   enable_interrupts(int_timer0);
   enable_interrupts(GLOBAL);

   VOLUME=read_eeprom(0);
   if(VOLUME == 0xFF)VOLUME=0x30;         //vÕ{[l
   if(VOLUME >  0x80)VOLUME=0x60;         //{[Ⴗ鎞0x60Ƃ

   disable_interrupts(GLOBAL);
   VS10xxRESET();               //VS10xx\tgZbg
   enable_interrupts(GLOBAL);

   delay_ms(250);               //҂ȂbeepoȂ

   beep(1,1);

   if(SDRESET()==0xFF)            //SDJ[h
   {
      beep(0,8);
      POWEROFF(0);
   }


   if(read_VFAT_info())            //FAT16łȂ
   {
      beep(1,8);
      POWEROFF(0);
   }



   SDIR_Cnt = search_SDIR(0xff);         //SDIRmF

   SD_mp3_check();               //SDzo

   if(SD_Total_MP3()==0)            //MP3t@CLmF
   {
      beep(1,4);
      POWEROFF(0);            //MP3t@CΓdoff[`
   }


   playMP3_SDIR = read_eeprom(1);
   playMP3_Num = read_eeprom(2);

   if(musicreset)               //ȔԃNA̎̓[g1Ȗڂ
   {
      playMP3_SDIR = 0;
      playMP3_Num = 1;
      beep(1,1);
   }


   if(check_eeprom() == 0)            //W[̖mF
   {
      playMP3_SDIR = 0;         //[g

      if(NEXT_search_SDIR() == 0)      //mFSDIRXLbv
         POWEROFF(0);
   }


   delay_ms(500);


   while(!(input(SW_POWER)))POWER_FLAG=0;      //powerXCb`Ă邩mF
   if(POWEROFF_FLAG)
      POWEROFF(1);

   delay_ms(500);

   while(!(input(SW_POWER)))POWER_FLAG=0;
   if(POWEROFF_FLAG)
      POWEROFF(1);

   battchek();               //Đ钼OɃobe[mF




   while(1)               //yĐ[`
   {
      char   response;
      char   n;


      if(POWEROFF_FLAG)
         POWEROFF(1);

      if(playMP3_Num > file_Cnt[playMP3_SDIR])
         playMP3_Num=1;

      if(playMP3_Num==0)
         playMP3_Num=file_Cnt[playMP3_SDIR];

      response=play_music(playMP3_Num);      //Đr̃XCb`


      if(response==1)
         POWEROFF(1);


      if(response==2)
      {
         beep(1,1);            //beep̌Ɋ荞ݗL
         ++playMP3_Num;
         FF_FLAG=0;
         while(!(input(SW_FF)))
         {
            if(NEXT_SDIR_FLAG)      //SDIR
            {
               beep(1,2);
               NEXT_SDIR_FLAG = 0;
               FF_FLAG=0;

               ++playMP3_SDIR;
               if(NEXT_search_SDIR() == 0)   //mFSDIRXLbv
                  POWEROFF(0);
            }
            FF_FLAG=0;
         }
      }


      if(response==3)
      {
         beep(1,1);
         --playMP3_Num;
         REW_FLAG=0;
         while(!(input(SW_REW)))
         {
            if(BACK_SDIR_FLAG)      //OSDIR
            {
               beep(1,2);
               BACK_SDIR_FLAG = 0;
               REW_FLAG=0;

               --playMP3_SDIR;
               if(BACK_search_SDIR() == 0)   //mFSDIRobN
                  POWEROFF(0);
            }
            REW_FLAG=0;
         }
      }


      if(response==9)
      {
         for(n=0;n<4;n++)
         {
            beep(0,1);
            beep(1,1);
         }
         POWEROFF(0);
      }


      if(response==0)
         ++playMP3_Num;

      battchek();

   }
}


////////////////////////////////
//
// ddmF
//
////////////////////////////////

void battchek(void)
{
   set_adc_channel(0);
   adv=read_adc(ADC_START_AND_READ);
   if(adv < 682)            //2.2V(2.2/3.3*1024)
   {
      if(adv < 651)         //2.1V(2.1/3.3*1024)
      {
         beep(0,5);
         POWEROFF(1);
      }
      else
      {
         beep(0,2);
      }
   }
}


////////////////////////////////
//
// MP3Đ
//
////////////////////////////////

char play_music(int fn)
{
   int16   i,j;
   int32   sec;
   int16   remain;
   int16   cn;

//   if(fn != search_MP3(fn))
//      return 9;

   search_play_file(fn,playMP3_SDIR);

   MP3_Size=(int32)RAM[28]+((int32)RAM[29]<<8)+((int32)RAM[30]<<16)+((int32)RAM[31]<<24);

   Cluster=(int16)RAM[26]+((int16)RAM[27]<<8);
   RemainSec=MP3_Size/512;
   remain=MP3_Size%512;

   if((Cluster==0xFFFF)||(Cluster<2))
      return 9;

   NextCluster=next_cluster(Cluster);

   cn=S_P_Cluster;
   sec=(((int32)Cluster-2)*(int32)S_P_Cluster+DATA_St)*512;


   VS10xxRESET();

   while(RemainSec > 0)
   {
      char   data;
      char   bit;

      if(SPI_read_open(sec))
         return 9;

      for(i=0;i<512;i++)
      {
         while(!(input(MP3_DREQ)));

         data=SDRX();

         output_high(MP3_BSYNC);
         for(bit=0;bit<8;bit++)
         {
            if(data & 0x80)
            {
               output_high(MP3_SI);
            }
            else
            {
               output_low(MP3_SI);
            }
            output_high(MP3_DCLK);
            data<<=1;
            output_low(MP3_DCLK);
            output_low(MP3_BSYNC);
         }
      }


                                 //SW`FbN

      if(POWER_FLAG)
      {
         while(!(input(MP3_DREQ)));
         beep(1,1);               //|[Y@\Ȃ͓s𖳌Ƃ
         while(!(input(SW_POWER)));
         if(POWEROFF_FLAG)
         {
            return 1;
         }
         else
         {
            POWER_FLAG=0;
            POSE_FLAG=1;
            while(!(POWER_FLAG))
            {
               if(LED_FLAG)
               {
                  output_high(LED_OUT);
               }
               else
               {
                  output_low(LED_OUT);
               }
            }
            output_high(LED_OUT);
            while(!(input(SW_POWER)))
               POWER_FLAG=0;
            POSE_FLAG=0;
            output_high(LED_OUT);
            if(POWEROFF_FLAG)
               return 1;
         }
      }


      disable_interrupts(GLOBAL);

      if(VOLCON_FLAG)
      {
         VS10xxCOMM(11,((int16)VOLUME<<8)|((int16)VOLUME));VOLCON_FLAG=0;
      }

      if(POWEROFF_FLAG)
         return 1;

      if(FF_FLAG)
      {
         while(!(input(MP3_DREQ)));
         return 2;
      }

      if(REW_FLAG)
      {
         while(!(input(MP3_DREQ)));
         return 3;
      }

      enable_interrupts(GLOBAL);


      --RemainSec;


      if(--cn > 0)
      {
         sec+=512;
      }
      else
      {
         if(NextCluster==0)
         {
            Cluster=next_cluster(Cluster);
         }
         else
         {
            Cluster=NextCluster;         //beep(1,1);
            NextCluster=0;
         }

      if((Cluster==0xFFFF)||(Cluster<2))
         break;                  //////////////////////?

      sec=(((int32)Cluster-2)*(int32)S_P_Cluster+DATA_St)*512;
      cn=S_P_Cluster;
      }
   }



   if(remain>0)
   {
      char   data;
      char   bit;

      if(SPI_read_open(sec))
         return 9;

      for(i=0;i<remain;i++)
      {
         while(!(input(MP3_DREQ)));

         data=SDRX();

         output_high(MP3_BSYNC);
         for(bit=0;bit<8;bit++)
         {
            if(data & 0x80)
            {
               output_high(MP3_SI);
            }
            else
            {
               output_low(MP3_SI);
            }
            output_high(MP3_DCLK);
            data<<=1;
            output_low(MP3_DCLK);
            output_low(MP3_BSYNC);
         }
      }
   }
   return 0;
}



////////////////////////////////
//
// BEEP
//
////////////////////////////////

void beep(char tone, char n)
{
   char i,j,k;
   int   BEEPBIT;

   disable_interrupts(GLOBAL);
   VOLUME+=13;
   VS10xxCOMM(11,((int16)VOLUME<<8)|((int16)VOLUME));
   delay_cycles(256);
   VS10xxRESET();
   VS10xxCOMM(0,0x0020);         //SM-TESTS(1)----------VS1011only
   delay_cycles(256);         //҂ȂbeepoȂƂ


   for(; n>0; --n)
   {

      if(tone)
      {
         for(i=0;i<8;i++)
         {
            BEEPBIT=(BEEP_H[i]);
            output_high(MP3_BSYNC);
            for(j=0;j<8;j++)
            {
               if(BEEPBIT & 0x80)
               {
                  output_high(MP3_SI);
               }
               else
               {
                  output_low(MP3_SI);
               }
               output_high(MP3_DCLK);
               BEEPBIT<<=1;
               output_low(MP3_DCLK);
               output_low(MP3_BSYNC);
            }
            output_high(MP3_SI);
         }


      }
      else
      {
         for(i=0;i<8;i++)
         {
            BEEPBIT=(BEEP_L[i]);
            output_high(MP3_BSYNC);
            for(j=0;j<8;j++)
            {
               if(BEEPBIT & 0x80)
               {
                  output_high(MP3_SI);
               }
               else
               {
                  output_low(MP3_SI);
               }
               output_high(MP3_DCLK);
               BEEPBIT<<=1;
               output_low(MP3_DCLK);
               output_low(MP3_BSYNC);
            }
            output_high(MP3_SI);
         }

      }

      delay_ms(50);

      for(k=0;k<2;k++)
      {
         for(i=0;i<8;i++)
         {
            BEEPBIT=(BEEP_S[i]);
            output_high(MP3_BSYNC);
            for(j=0;j<8;j++)
            {
               if(BEEPBIT & 0x80)
               {
                  output_high(MP3_SI);
               }
               else
               {
                  output_low(MP3_SI);
               }
               output_high(MP3_DCLK);
               BEEPBIT<<=1;
               output_low(MP3_DCLK);
               output_low(MP3_BSYNC);
            }
            output_high(MP3_SI);
         }
      }
      delay_ms(50);
   }
   VS10xxCOMM(0,0x0000);         //SM-TESTS(0)----------VS1011only
   delay_cycles(256);
   VOLUME-=13;
   VS10xxCOMM(11,((int16)VOLUME<<8)|((int16)VOLUME));
   delay_cycles(256);
   enable_interrupts(GLOBAL);
}


////////////////////////////////
//
// VS10xxCjVZbg
//
////////////////////////////////

void VS10xxRESET(void)
{
   VS10xxCOMM(0,0x0004);         //Zbg
   delay_cycles(256);         //EFCg
   VS10xxCOMM(0,0x0000);         //1001Rp`u[h

   while(!input(MP3_DREQ));         //X|X҂
   VS10xxCOMM(3,0x9800);         //0x8000+12288000/2000
   delay_cycles(256);
   VS10xxCOMM(11,((int16)VOLUME<<8)|((int16)VOLUME));
   delay_cycles(256);
}



////////////////////////////////
//
// VS10xxR}hM
//
////////////////////////////////

void VS10xxCOMM(char addr,int16 arg)
{
   output_low(MP3_CS);
   VS10xxWR(2);
   VS10xxWR(addr);
   VS10xxWR(arg>>8);
   VS10xxWR(arg);
   output_high(MP3_CS);
}



////////////////////////////////
//
// VS10xxrbgxM
//
////////////////////////////////

void VS10xxWR(char data)
{
   char i;

   for(i=0;i<8;i++)
   {
      if(data & 0x80)
      {
         output_high(MP3_SI);
      }
      else
      {
         output_low(MP3_SI);
      }
      delay_cycles(4);
      output_high(MP3_SCLK);
      delay_cycles(4);
      data<<=1;
      output_low(MP3_SCLK);
      delay_cycles(4);
   }
   output_high(MP3_SI);
   delay_cycles(4);
}



////////////////////////////////
//
// Vbg_E
//
////////////////////////////////

void POWEROFF(char c)
{
   char i;

   delay_ms(100);

   if(c)
   {
      i=read_eeprom(2);
      if(i != playMP3_Num)
      {
         write_eeprom(2,playMP3_Num);
      }

      i=read_eeprom(1);
      if(i != playMP3_SDIR)
      {
         write_eeprom(1,playMP3_SDIR);
      }

      i=read_eeprom(0);
      if(i != VOLUME)
      {
         write_eeprom(0,VOLUME);
      }
   }
   else
   {
      write_eeprom(1,0);
      write_eeprom(2,1);
   }

   //delay_ms(500);
   //beep(0,1);
   delay_ms(100);
   output_low(MP3_RS);
   delay_ms(100);
   output_low(LED_OUT);
   output_low(POWER_LOCK);
   sleep();
}


////////////////////////////////
//
// SDJ[hSPIM
//
////////////////////////////////

void SDTX(char sddata)
{
   int i;

   for(i = 0; i < 8; i++)
   {
      output_high(SPI_DI);
      if(sddata & 0x80)
      {
         output_high(SPI_DI);
      }
      else
      {
         output_low(SPI_DI);
      }
      output_low(SPI_CK);
      sddata <<= 1;
      output_high(SPI_CK);
   }
   output_low(SPI_DI);
}



////////////////////////////////
//
// SDJ[hSPIM
//
////////////////////////////////

char SDRX(void)
{
   char input;
   char i;

   input=0;

   output_high(SPI_DI);

   for(i=0;i<8;i++)
   {
      output_low(SPI_CK);
      delay_cycles(1);
//      input |=input(SPI_DO);   //////////ǂI
      output_high(SPI_CK);
      input |=input(SPI_DO);   //////////ǂI
      if(i<7)input<<=1;
   }
   return input;
}



////////////////////////////////
//
// SDJ[hCjVSPI[hڍs
//
////////////////////////////////

char SDRESET(VOID)
{
   char   c;

   output_high(SPI_CS);
   for (c=0; c < 50; c++)
   {
      SDTX(0xFF);
   }

   output_low(SPI_CS);

   SDCMD(0, 0);
//   do
//   {
//      c = SDCMD(0, 0);
//   }
//   while((c != 1)&&(c != 0xFF));

   while((c != 1)&&(c != 0xFF))
      c = SDCMD(0, 0);

//   do
//   {
//      c = SDCMD(1, 0);
//   }while(c == 1);

   while(c == 1)
      c = SDCMD(1, 0);

//   SPI_CS_OFF();

   return c;
}



////////////////////////////////
//
// SDJ[hR}hM
//
////////////////////////////////

char SDCMD(char cmd,int32 arg)
{
   int16   i;
   int   r;

   for (i=0; i < 2048; i++)
   {
      r = SDRX();
      if (r == 0xFF)
         break;
   }
   if (r != 0xFF)
      return 1;

   SDTX(cmd|0x40);
   SDTX(arg>>24);
   SDTX(arg>>16);
   SDTX(arg>>8);
   SDTX(arg);
   SDTX(0x95);

   for(i = 0; i < 2048; i++)
   {
      r = SDRX();
      if (r == 0xFE)
         break;
      if (!(r & 0x80))
         break;
   }
   return r;
}


////////////////////////////////
//
// SDJ[hFAT
//
////////////////////////////////

char read_VFAT_info(void)
{
   int32   sec;
   int32   bpb;
   int32   n;

   read_32(446);                     //MBR
   bpb = (int32)RAM[8] + ((int32)RAM[9]<<8);
   read_32((int32)bpb * 512);
   n = (int32)RAM[11] + ((int32)RAM[12] << 8);         //ZN^
   if (n != 512)
   {
      return 1;
   }
   S_P_Cluster = RAM[13];
   FAT_St = bpb + (int32)RAM[14] + ((int32)RAM[15] << 8);
   RDE_Cnt = (int32)RAM[17] + ((int32)RAM[18] << 8);
   n = (int32)RAM[22] + ((int32)RAM[23] << 8);         //FATZN^
   if (n == 0)
   {
      return 1;                  //FAT32
   }
   DIR_St = (int32)FAT_St + (int32)RAM[16] * n;
   n = RDE_Cnt / 16;
   if (RDE_Cnt % 16)
   {
      n++;
   }
   DATA_St = (int32)DIR_St + (int32)n;

   sec = (int32)RAM[19] + ((int32)RAM[20] << 8);         //ZN^
   if (sec == 0)
   {
      read_32((int32)bpb * 512 + 32);
      sec = (int32)RAM[0] + ((int32)RAM[1] << 8)
         + ((int32)RAM[2] << 16) + ((int32)RAM[3] << 24);
   }
   sec -= FAT_St;
   sec /= S_P_Cluster;

   if(sec >= 0x1000)
   {
      return 0;                  //FAT16
   }
   else
   {
      return 1;                  //FAT12
   }
}


////////////////////////////////
//
// SDJ[h32byte荞
//
////////////////////////////////

void read_32(int32 addr)
{
   int16   i, b;

   if (SPI_read_open(addr & 0xFFFFFE00))
      return;
   b = (int32)addr & 0x01FF;
   for (i=0; i < 512; i++)
   {
      if (i == b)
      {
         int   n;
         for (n = 0; n < 32; n++)
         {
            RAM[n] = SDRX();
            i++;
         }
      }
      else
      {
         SDRX();
      }
   }
   SPI_read_close();

}


////////////////////////////////
//
// SDJ[hǂݍ݊Jn
//
////////////////////////////////

char SPI_read_open(int32 adrs)
{
   int16   i;
   char   r;
   char   c;
   char   retry;

   for (retry = 0; retry < 100; retry++)
   {
      output_low(SPI_CS);
      r = SDCMD(17, adrs);
      if (r == 0)
      {
         for(i=0; i < 5000; i++)
         {
            c = SDRX();
            if (c == 0xFE)
            {
               return 0;   //
            }
         }
      }
      else
      {
         if (r == 0xFE)
         {
            return 0;      //
         }
         output_high(SPI_CS);
         delay_cycles(32);
      }
   }
   return 1;               //NG
}



////////////////////////////////
//
// SDJ[hǂݍݏI
//
////////////////////////////////

void SPI_read_close(void)
{
   int16   i;

   SDRX();
   SDRX();
   for (i=0; i < 2048; i++)
   {
      if (SDRX() == 0xFF)
         break;
   }
}



////////////////////////////////
//
// SDJ[h2bytef[^荞
//
////////////////////////////////

int16 read_word(int32 addr)
{
   int16   i;
   int16   b;
   char   *p;

   b = (int16)addr & 511;
   addr &= 0xFFFFFE00;

   if (addr != FAT_sec)
   {
      if (SPI_read_open(addr))
         return 0;
      for(p=FAT_RAM; p < (FAT_RAM + 512 ); )
      {
         *p++ = SDRX( );
      }
      SPI_read_close();
      FAT_sec = addr;
   }

   i = (int16)FAT_RAM[b++];
   i |= ((int16)FAT_RAM[b] << 8);

   return i;
}


////////////////////////////////
//
// NX^Zo
//
////////////////////////////////

int16 next_cluster(int16 g)
{
   int32   sect;

   sect = (int32)FAT_St * 512 + (int32)g * 2;
   g = read_word(sect);
   if (g >= 0xfff8)
      g = 0xFFFF;
   return g;
}



////////////////////////////////
//
// [gMP3t@C
//
////////////////////////////////

char search_MP3(char num)
{
   int32   ent;
   int32   sec;
   char   i, j;
   char   n;

   n = 0;

   sec = (int32)DIR_St * 512;
   for (ent=0; ent < RDE_Cnt; )
   {
      if (SPI_read_open(sec))
         return n;
      for (i=0; i < 16; i++)
      {
         for (j = 0; j < 32; j++)
         {
            RAM[j] = SDRX();
         }
         if (RAM[0] == 0)
            break;


         if (((RAM[26] != 0)||(RAM[27] != 0))&&(RAM[0] != 0xE5)
            &&(!(RAM[11] & 0x18))&&(RAM[8]=='M')&&(RAM[9]=='P')&&(RAM[10]=='3'))
         {
            n++;
            if (--num == 0)
               break;
         }
         ent++;
      }
      SPI_read_close();
      if (RAM[0] == 0)
         break;
      if (num == 0)
         break;
      sec += 512;            //̃ZN^
   }

   return n;
}



////////////////////////////////
//
// SDIR
//
////////////////////////////////

char search_SDIR(char num)
{
   int32   ent;
   int32   sec;
   char   i, j;
   char   n;

   n = 0;

   sec = (int32)DIR_St * 512;
   for (ent=0; ent < RDE_Cnt; )
   {
      if (SPI_read_open(sec))
         return n;
      for (i=0; i < 16; i++)
      {
         for (j = 0; j < 32; j++)
         {
            RAM[j] = SDRX();
         }
         if (RAM[0] == 0)
            break;


         if (((RAM[26] != 0)||(RAM[27] != 0))&&(RAM[0] != 0xE5)&&(RAM[11] == 0x10))
         {
            n++;
            if (--num == 0)
               {
                  SPI_read_open((((int32)RAM[26]+((int32)RAM[27]<<8)-2)
                     *((int32)S_P_Cluster)+((int32)DATA_St))*512);
                  for (j = 0; j < 32; j++)
                  {
                     RAM[j] = SDRX();
                  }

                  break;

               }
         }

         ent++;
      }
      SPI_read_close();
      if (RAM[0] == 0)
         break;
      if (num == 0)
         break;
      sec += 512;            //̃ZN^
   }

   return n;
}





////////////////////////////////
//
// TufBNgMP3t@C
//
////////////////////////////////

char search_SDIR_MP3(char num)
{
   int32   ent;
   int32   sec;
   char   i, j;
   char   n;

   n = 0;

   sec = (((int32)RAM[26]+((int32)RAM[27]<<8)-2)*((int32)S_P_Cluster)+((int32)DATA_St))*512;


   for (ent=0; ent < RDE_Cnt; )
   {
      if (SPI_read_open(sec))
         return n;
      for (i=0; i < 16; i++)
      {
         for (j = 0; j < 32; j++)
         {
            RAM[j] = SDRX();
         }
         if (RAM[0] == 0)
            break;


         if (((RAM[26] != 0)||(RAM[27] != 0))&&(RAM[0] != 0xE5)
            &&(!(RAM[11] & 0x18))&&(RAM[8]=='M')&&(RAM[9]=='P')&&(RAM[10]=='3'))
         {
            n++;
            if (--num == 0)
               break;
         }
         ent++;
      }
      SPI_read_close();
      if (RAM[0] == 0)
         break;
      if (num == 0)
         break;
      sec += 512;            //̃ZN^
   }

   return n;
}




////////////////////////////////
//
// ĐMP3t@C
//
////////////////////////////////

void search_play_file(int num, int sdir)
{
   if(sdir == 0)
   {
      search_MP3(num);
   }
   else
   {
      search_SDIR(sdir);
      search_SDIR_MP3(num);
   }
}






////////////////////////////////
//
// SDJ[hMP3t@Czo
//
////////////////////////////////

void SD_mp3_check(void)
{

   char   i, j, k;

   j = (int)SDIR_Cnt;

   k = 0;

   for (i = 0; i < 32; i++)      //WX^I[NA
   {
      file_Cnt[i] = 0;
   }

   file_Cnt[0]=search_MP3(0xFF);

   for (i = 1; i < 32; i++)
   {

         if(j == 0)      //SDIR0Ȃ߂
            break;
         k++;
         search_SDIR(k);
         file_Cnt[i]=search_SDIR_MP3(0xFF);
         if(k == j)
            break;

   }

}



////////////////////////////////
//
// SDJ[hMP3t@CL
//
////////////////////////////////

char SD_Total_MP3(void)
{
   char   i;
   int16   n;

   n = 0;

   for (i = 0; i < 32; i++)
      {
         n=n+(int16)file_Cnt[i];
      }

   if(n == 0x0000)
      {
         return 0;      //MP3t@C1Ȃ
      }
      else
      {
         return 1;      //MP3t@C݂
      }


}




////////////////////////////////
//
// W[e̖mF
//
////////////////////////////////

char check_eeprom(void)
{

   if(playMP3_SDIR > SDIR_Cnt)
      return 0;            //NG

   if(playMP3_Num > file_Cnt[playMP3_SDIR])
      {
         return 0;         //NG
      }
      else
      {
         return 1;         //OK
      }

}



////////////////////////////////
//
// ISDIRMP3t@CLmF
// MP3t@CSDIRi߂
//
////////////////////////////////

char NEXT_search_SDIR(void)
{
   char   i;

   if(playMP3_SDIR > SDIR_Cnt)
      playMP3_SDIR = 0;

   for(i=0;i=(SDIR_Cnt+1);i++)
   {
      if(file_Cnt[playMP3_SDIR] == 0)
      {         
         playMP3_SDIR++;

         if(playMP3_SDIR > SDIR_Cnt)
            playMP3_SDIR = 0;

      }
      else
      {
         playMP3_Num = 1;
         return 1;         //mFI
      }
   }

   return 0;               //ُ
}



////////////////////////////////
//
// ISDIRMP3t@CLmF
// MP3t@CSDIR߂
//
////////////////////////////////

char BACK_search_SDIR(void)
{
   char   i;

   if(playMP3_SDIR == 0xFF)
      playMP3_SDIR = SDIR_Cnt;

   for(i=0;i=(SDIR_Cnt+1);i++)
   {
      if(file_Cnt[playMP3_SDIR] == 0)
      {         
         playMP3_SDIR--;

         if(playMP3_SDIR == 0xFF)
            playMP3_SDIR = SDIR_Cnt;

      }
      else
      {
         playMP3_Num = 1;
         return 1;         //mFI
      }
   }

   return 0;               //ُ
}




















//write_eeprom(0x00,RAM[0]);
//write_eeprom(0x01,RAM[1]);
//write_eeprom(0x02,RAM[2]);
//write_eeprom(0x03,RAM[3]);
//write_eeprom(0x04,RAM[4]);
//write_eeprom(0x05,RAM[5]);
//write_eeprom(0x06,RAM[6]);
//write_eeprom(0x07,RAM[7]);
//write_eeprom(0x08,RAM[8]);
//write_eeprom(0x09,RAM[9]);
//write_eeprom(0x0a,RAM[10]);
//write_eeprom(0x0b,RAM[11]);
//write_eeprom(0x0c,RAM[12]);
//write_eeprom(0x0d,RAM[13]);
//write_eeprom(0x0e,RAM[14]);
//write_eeprom(0x0f,RAM[15]);
//write_eeprom(0x10,RAM[16]);
//write_eeprom(0x11,RAM[17]);
//write_eeprom(0x12,RAM[18]);
//write_eeprom(0x13,RAM[19]);
//write_eeprom(0x14,RAM[20]);
//write_eeprom(0x15,RAM[21]);
//write_eeprom(0x16,RAM[22]);
//write_eeprom(0x17,RAM[23]);
//write_eeprom(0x18,RAM[24]);
//write_eeprom(0x19,RAM[25]);
//write_eeprom(0x1a,RAM[26]);
//write_eeprom(0x1b,RAM[27]);
//write_eeprom(0x1c,RAM[28]);
//write_eeprom(0x1d,RAM[29]);
//write_eeprom(0x1e,RAM[30]);
//write_eeprom(0x1f,RAM[31]);

//write_eeprom(0x10,RAM[0]);
//write_eeprom(0x11,RAM[1]);
//write_eeprom(0x12,RAM[2]);
//write_eeprom(0x13,RAM[3]);
//write_eeprom(0x14,RAM[4]);
//write_eeprom(0x15,RAM[5]);
//write_eeprom(0x16,RAM[6]);
//write_eeprom(0x17,RAM[7]);
//write_eeprom(0x18,RAM[8]);
//write_eeprom(0x19,RAM[9]);
//write_eeprom(0x1a,RAM[10]);
//write_eeprom(0x1b,RAM[11]);
//write_eeprom(0x1c,RAM[12]);
//write_eeprom(0x1d,RAM[13]);
//write_eeprom(0x1e,RAM[14]);
//write_eeprom(0x1f,RAM[15]);
//write_eeprom(0x20,RAM[16]);
//write_eeprom(0x21,RAM[17]);
//write_eeprom(0x22,RAM[18]);
//write_eeprom(0x23,RAM[19]);
//write_eeprom(0x24,RAM[20]);
//write_eeprom(0x25,RAM[21]);
//write_eeprom(0x26,RAM[22]);
//write_eeprom(0x27,RAM[23]);
//write_eeprom(0x28,RAM[24]);
//write_eeprom(0x29,RAM[25]);
//write_eeprom(0x2a,RAM[26]);
//write_eeprom(0x2b,RAM[27]);
//write_eeprom(0x2c,RAM[28]);
//write_eeprom(0x2d,RAM[29]);
//write_eeprom(0x2e,RAM[30]);
//write_eeprom(0x2f,RAM[31]);

//write_eeprom(0x30,file_Cnt[0]);
//write_eeprom(0x31,file_Cnt[1]);
//write_eeprom(0x32,file_Cnt[2]);
//write_eeprom(0x33,file_Cnt[3]);
//write_eeprom(0x34,file_Cnt[4]);
//write_eeprom(0x35,file_Cnt[5]);
//write_eeprom(0x36,file_Cnt[6]);
//write_eeprom(0x37,file_Cnt[7]);
//write_eeprom(0x38,file_Cnt[8]);
//write_eeprom(0x39,file_Cnt[9]);
//write_eeprom(0x3a,file_Cnt[10]);
//write_eeprom(0x3b,file_Cnt[11]);
//write_eeprom(0x3c,file_Cnt[12]);
//write_eeprom(0x3d,file_Cnt[13]);
//write_eeprom(0x3e,file_Cnt[14]);
//write_eeprom(0x3f,file_Cnt[15]);
//write_eeprom(0x40,file_Cnt[16]);
//write_eeprom(0x41,file_Cnt[17]);
//write_eeprom(0x42,file_Cnt[18]);
//write_eeprom(0x43,file_Cnt[19]);
//write_eeprom(0x44,file_Cnt[20]);
//write_eeprom(0x45,file_Cnt[21]);
//write_eeprom(0x46,file_Cnt[22]);
//write_eeprom(0x47,file_Cnt[23]);
//write_eeprom(0x48,file_Cnt[24]);
//write_eeprom(0x49,file_Cnt[25]);
//write_eeprom(0x4a,file_Cnt[26]);
//write_eeprom(0x4b,file_Cnt[27]);
//write_eeprom(0x4c,file_Cnt[28]);
//write_eeprom(0x4d,file_Cnt[29]);
//write_eeprom(0x4e,file_Cnt[30]);
//write_eeprom(0x4f,file_Cnt[31]);

//write_eeprom(0x30,file_Cnt[0]);
//write_eeprom(0x31,file_Cnt[1]);
//write_eeprom(0x32,file_Cnt[2]);
//write_eeprom(0x33,file_Cnt[3]);
//write_eeprom(0x34,file_Cnt[4]);
//write_eeprom(0x35,file_Cnt[5]);
//write_eeprom(0x36,file_Cnt[6]);
//write_eeprom(0x37,file_Cnt[7]);
//write_eeprom(0x38,file_Cnt[8]);
//write_eeprom(0x39,file_Cnt[9]);
//write_eeprom(0x3a,file_Cnt[10]);
//write_eeprom(0x3b,file_Cnt[11]);
//write_eeprom(0x3c,file_Cnt[12]);
//write_eeprom(0x3d,file_Cnt[13]);
//write_eeprom(0x3e,file_Cnt[14]);
//write_eeprom(0x3f,file_Cnt[15]);
//write_eeprom(0x40,file_Cnt[16]);
//write_eeprom(0x41,file_Cnt[17]);
//write_eeprom(0x42,file_Cnt[18]);
//write_eeprom(0x43,file_Cnt[19]);
//write_eeprom(0x44,file_Cnt[20]);
//write_eeprom(0x45,file_Cnt[21]);
//write_eeprom(0x46,file_Cnt[22]);
//write_eeprom(0x47,file_Cnt[23]);
//write_eeprom(0x48,file_Cnt[24]);
//write_eeprom(0x49,file_Cnt[25]);
//write_eeprom(0x4a,file_Cnt[26]);
//write_eeprom(0x4b,file_Cnt[27]);
//write_eeprom(0x4c,file_Cnt[28]);
//write_eeprom(0x4d,file_Cnt[29]);
//write_eeprom(0x4e,file_Cnt[30]);
//write_eeprom(0x4f,file_Cnt[31]);

//write_eeprom(0x51,(int16)n);
//write_eeprom(0x50,((int16)n >> 8));

